/*
    gUserMan- A GTK+ User manager
    Copyright (C) 1999 Scott Fritzinger

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "main.h"

extern gint     users_changed;
extern gint 	groups_changed;
extern gint	debug_mode;
extern gchar   *salt;

extern GtkWidget *users_clist;
extern GtkWidget *groups_clist;

       gchar	groups_sort_type = '2';

GtkWidget *create_groups_widget () {

	GtkWidget *mainbox, *hbox, *button, *scrwin, 
		  *add, *edit, *remove, *save, *quit;
	gint x;
	gint num_columns = 4; 

	mainbox = gtk_vbox_new(FALSE, 0);
	gtk_widget_show(mainbox);
	gtk_widget_hide(mainbox);

	/* Create the horizontal box to hold the buttons */
	hbox = gtk_hbox_new(FALSE, 0);
	gtk_widget_show(hbox);
	gtk_box_pack_start(GTK_BOX(mainbox), hbox, FALSE, FALSE, 0);

	button = gtk_button_new_with_label("Group");
	gtk_widget_show(button);
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
                GTK_SIGNAL_FUNC(sort_group_clicked), (gpointer)"0");
	gtk_widget_set_usize(button,85,20);
	gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 0);

	button = gtk_button_new_with_label("Password");
	gtk_widget_show(button);
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
                GTK_SIGNAL_FUNC(sort_group_clicked), (gpointer)"1");
	gtk_widget_set_usize(button,65,20);
	gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 0);

	button = gtk_button_new_with_label("GID");
	gtk_widget_show(button);
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
                GTK_SIGNAL_FUNC(sort_group_clicked), (gpointer)"2");
	gtk_widget_set_usize(button,55,20);
	gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 0);

	button = gtk_button_new_with_label("Users");
	gtk_widget_show(button);
	gtk_widget_set_usize(button,225,20);
	gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);

	groups_clist = gtk_clist_new(num_columns);
	gtk_widget_show(groups_clist);
	gtk_clist_set_shadow_type(GTK_CLIST(groups_clist), GTK_SHADOW_NONE);
	gtk_clist_set_column_width(GTK_CLIST(groups_clist), 0, 75);
	gtk_clist_set_column_width(GTK_CLIST(groups_clist), 1, 60);
	gtk_clist_set_column_width(GTK_CLIST(groups_clist), 2, 50);
	gtk_clist_set_column_width(GTK_CLIST(groups_clist), 3, 225);
	for (x=0; x<num_columns; x++)
		gtk_clist_set_column_resizeable(
			GTK_CLIST(groups_clist),x,FALSE);

        gtk_clist_set_compare_func(GTK_CLIST(groups_clist),
                (GtkCListCompareFunc)compare_groups_clist);

	read_groups(groups_clist);

	gtk_clist_sort(GTK_CLIST(groups_clist));

	gtk_signal_connect(GTK_OBJECT(groups_clist), "select_row",
                GTK_SIGNAL_FUNC(group_clist_clicked), NULL);

	/* Create the scrolled window to hold the clist */
	scrwin = gtk_scrolled_window_new(NULL, NULL);
	gtk_widget_show(scrwin);
	gtk_widget_set_usize(scrwin, 525, 200);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrwin),
		GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrwin),
		groups_clist);
	gtk_box_pack_start_defaults(GTK_BOX(mainbox), scrwin);

	/* Create the horizontal box to hold the buttons */
	hbox = gtk_hbox_new(TRUE, 3);
	gtk_widget_show(hbox);
	gtk_box_pack_start(GTK_BOX(mainbox), hbox, FALSE, FALSE, 0);

	/* Create the add button */
	add = gtk_button_new_with_label("Add");
	gtk_widget_show(add);
	gtk_box_pack_start_defaults(GTK_BOX(hbox), add);
	gtk_signal_connect_object(GTK_OBJECT(add), "clicked",
		GTK_SIGNAL_FUNC(add_group_clicked), (gpointer)groups_clist);

	/* Create the edit button */
	edit = gtk_button_new_with_label("Edit");
	gtk_widget_show(edit);
	gtk_box_pack_start_defaults(GTK_BOX(hbox), edit);
	gtk_signal_connect_object(GTK_OBJECT(edit), "clicked",
		GTK_SIGNAL_FUNC(edit_group_clicked), (gpointer)groups_clist);

	/* Create the remove button */
	remove = gtk_button_new_with_label("Remove");
	gtk_widget_show(remove);
	gtk_box_pack_start_defaults(GTK_BOX(hbox), remove);
	gtk_signal_connect_object(GTK_OBJECT(remove), "clicked",
		GTK_SIGNAL_FUNC(remove_group_clicked), (gpointer)groups_clist);

	/* Create the save button */
	save = gtk_button_new_with_label("Save Groups");
	gtk_widget_show(save);
	gtk_box_pack_start_defaults(GTK_BOX(hbox), save);
	gtk_signal_connect_object(GTK_OBJECT(save), "clicked",
		GTK_SIGNAL_FUNC(save_groups_clicked), (gpointer)groups_clist);

	/* Create the quit button */
	quit = gtk_button_new_with_label("Quit");
	gtk_widget_show(quit);
	gtk_box_pack_start_defaults(GTK_BOX(hbox), quit);
	gtk_signal_connect_object(GTK_OBJECT(quit), "clicked",
		GTK_SIGNAL_FUNC(main_quit), NULL);

	return (mainbox);
}

gint compare_groups_clist (GtkCList *clist,
			  gpointer one,
			  gpointer two) {
  
        struct group *grp1 = ((GtkCListRow *)one)->data;
        struct group *grp2 = ((GtkCListRow *)two)->data; 

	switch (groups_sort_type) {
		case '0':
			return(strcmp(grp1->gr_name, grp2->gr_name));
			break;
		case '1':
			return(strcmp(grp1->gr_passwd, grp2->gr_passwd));
			break;
		default:
			if (grp1->gr_gid < grp2->gr_gid)
				return(-1);
			if (grp1->gr_gid > grp2->gr_gid)
				return(1);
	}
	return(0);
}

void read_groups (GtkWidget *clist) {

	struct group *grp, *copy;
	FILE *gfile = NULL;
	gchar **row;

	gfile = fopen(group_file, "r");
	while ((grp = fgetgrent(gfile)) != NULL) {
		copy = copy_group(grp);
		row = group_to_row(copy);
		gtk_clist_append(GTK_CLIST(clist), row);
		gtk_clist_set_row_data(GTK_CLIST(clist), 
			GTK_CLIST(clist)->rows-1, copy);
	}
	fclose(gfile);
}

void save_groups (GtkWidget *clist) {

	FILE *gfile;

	struct group *grp;
	int x, y;
	gchar oldsort;
	
	oldsort = groups_sort_type;
	groups_sort_type = '2';
	gtk_clist_sort(GTK_CLIST(groups_clist));

	if (debug_mode)
		gfile = fopen("group.debug", "w+");
	   else
		gfile = fopen(group_file, "w+");

	for (y=0; y<GTK_CLIST(clist)->rows; y++) {
		grp = gtk_clist_get_row_data(GTK_CLIST(clist), y);
/*	Why is putgrent() an implicit declaration here? */
/*		putgrent(grp, gfile); 			*/

		fprintf(gfile, "%s:%s:%i:", grp->gr_name, 
			grp->gr_passwd, grp->gr_gid);
		x=0;
		while (grp->gr_mem[x] != NULL) {
			fprintf(gfile, "%s", grp->gr_mem[x]);
			if (grp->gr_mem[x+1] !=NULL)
				fprintf(gfile, ",");
			x++;
		}
		fprintf(gfile, "\n");
	}

	fclose(gfile);

	groups_sort_type = oldsort;
	gtk_clist_sort(GTK_CLIST(groups_clist));
	groups_changed = 0;
}

void sort_group_clicked (gchar *type) {

	groups_sort_type = type[0];
	gtk_clist_sort(GTK_CLIST(groups_clist));
}

gint group_clist_clicked (GtkWidget *clist, gint row, gint col, 
			GdkEvent *event) {

	if (event->type == GDK_2BUTTON_PRESS)
		edit_group_clicked(clist);
	return (FALSE);
}

void add_group_clicked(GtkWidget *clist) {

	edit_group_dialog(clist, TRUE);
}

void edit_group_clicked(GtkWidget *clist) {

	edit_group_dialog(clist, FALSE);
}

void remove_group_clicked(GtkWidget *clist) {

	gint row_number;
	struct group *grp;

	if (!GTK_CLIST(clist)->selection) {
		message_window("Nothing Selected", 
		"Nothing is selected to be removed");
		return;
	}

	if (!confirm_window("Remove Group", 
	"Are you sure you want to remove the group?"))
		return;

	row_number = GTK_CLIST(clist)->focus_row;
	grp = gtk_clist_get_row_data(GTK_CLIST(clist), row_number);
	free_group(grp);
	gtk_clist_remove(GTK_CLIST(clist), row_number);

	groups_changed = 1;
}

void edit_group_dialog(GtkWidget *clist, int new) {

	GtkWidget *dialog, *table, *label, *vsep, *scrwin, *item,
		  *name, *password, *change, *gid, *users,
		  *ok, *cancel;
	GtkTooltips *tooltip;

	gchar **row;
	gchar   num[32];
	gint    row_number, x, y;

	struct User  *user;
	struct group *grp;

	gchar  *row_text;
	GSList *members, *node;
	GList *list;

        if ((!GTK_CLIST(clist)->selection) && (!new)) {
                message_window("Nothing Selected",
                "Nothing is selected to be edited");
                return;
        }

	dialog = gtk_dialog_new();
        gtk_widget_realize(dialog);
        gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_CENTER);
        gtk_window_set_title(GTK_WINDOW(dialog), "Edit User Template");
        gtk_container_set_border_width(GTK_CONTAINER(dialog), 5);

	table = gtk_table_new (8,4,FALSE);
	gtk_widget_show(table);
	gtk_table_set_row_spacings(GTK_TABLE(table), 3);
        gtk_table_set_col_spacings(GTK_TABLE(table), 3);
	gtk_box_pack_start_defaults(GTK_BOX(GTK_DIALOG(dialog)->vbox),
                table);

	label = gtk_label_new("Name:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,0,1);

	label = gtk_label_new("Password:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,1,2);

	label = gtk_label_new("Group ID:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,3,4);

	label = gtk_label_new(" ");
	gtk_widget_show(label);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0,2,4,5);
	label = gtk_label_new(" ");
	gtk_widget_show(label);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0,2,5,6);
	label = gtk_label_new(" ");
	gtk_widget_show(label);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0,2,6,7);
	label = gtk_label_new(" ");
	gtk_widget_show(label);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0,2,7,8);

	label = gtk_label_new("Group Members:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 3,4,0,1);

        vsep = gtk_vseparator_new();
        gtk_widget_show(vsep);
        gtk_table_attach_defaults(GTK_TABLE(table), vsep, 2,3,0,8);

	name = gtk_entry_new();
	gtk_widget_show(name);
	gtk_table_attach_defaults(GTK_TABLE(table), name, 1,2,0,1);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, name, "Group name", NULL);

	password = gtk_entry_new();
	gtk_widget_show(password);
	gtk_table_attach_defaults(GTK_TABLE(table), password, 1,2,1,2);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, password, 
"Group password. \
(Leave blank for no group password, or set to 'x' to prevent group \
authentication", NULL);

	change = gtk_button_new_with_label("Set / Change Password");
	gtk_widget_show(change);
	gtk_table_attach_defaults(GTK_TABLE(table), change, 1,2,2,3);
	gtk_signal_connect_object(GTK_OBJECT(change), "clicked", 
		GTK_SIGNAL_FUNC(set_password_dialog), (gpointer)password);

	gid = gtk_entry_new();
	gtk_widget_show(gid);
	gtk_table_attach_defaults(GTK_TABLE(table), gid, 1,2,3,4);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, gid, "Group ID Number", NULL);

	users = gtk_list_new();
	gtk_widget_show(users);
	gtk_list_set_selection_mode(GTK_LIST(users),
		GTK_SELECTION_MULTIPLE);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, users, "Members of this group", NULL);

	row_number = GTK_CLIST(clist)->focus_row;
	grp = gtk_clist_get_row_data(GTK_CLIST(clist), row_number);
	for (x=0; x<GTK_CLIST(users_clist)->rows; x++) {
		user = gtk_clist_get_row_data(GTK_CLIST(users_clist),x);
		item = gtk_list_item_new_with_label(user->login);
		gtk_widget_show(item);
		gtk_container_add(GTK_CONTAINER(users), item);
		y = 0;
		while ((grp->gr_mem[y] != NULL) && (!new)) {
			if (strcmp(user->login, grp->gr_mem[y]) == 0)
				gtk_list_select_item(GTK_LIST(users),x);
			y++;
		}
	}

	scrwin = gtk_scrolled_window_new(NULL, NULL);
	gtk_widget_show(scrwin);
	gtk_widget_set_usize(scrwin, 100, 50);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrwin),
		GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
	gtk_table_attach_defaults(GTK_TABLE(table), scrwin, 3,4,1,8);
	gtk_scrolled_window_add_with_viewport(
		GTK_SCROLLED_WINDOW(scrwin), users);

	ok = gtk_button_new_with_label("OK");
	gtk_widget_show(ok);
	gtk_box_pack_start_defaults(
		GTK_BOX(GTK_DIALOG(dialog)->action_area), ok);

	cancel = gtk_button_new_with_label("Cancel");
	gtk_widget_show(cancel);
	gtk_box_pack_start_defaults(
		GTK_BOX(GTK_DIALOG(dialog)->action_area), cancel);

	if (!new) {
		gtk_entry_set_text(GTK_ENTRY(name), grp->gr_name);
		gtk_entry_set_text(GTK_ENTRY(password), grp->gr_passwd);
		sprintf(num, "%i", grp->gr_gid);
		gtk_entry_set_text(GTK_ENTRY(gid), num);
	}  else {
		sprintf(num, "%i", 
			((struct group*)gtk_clist_get_row_data(
			GTK_CLIST(clist),GTK_CLIST(clist)->rows-1))
			->gr_gid+1);
		gtk_entry_set_text(GTK_ENTRY(gid), num);		
	}

	gtk_widget_show(dialog);

	if (wait_for_hide(dialog, ok, cancel) == 0) {
		if (GTK_IS_OBJECT(dialog))
			gtk_widget_destroy(dialog);
		return;
	}
	if (!GTK_IS_OBJECT(dialog))
		return;

	groups_changed = 1;

	if (!new) {
		grp = gtk_clist_get_row_data(GTK_CLIST(clist), row_number);
		free_group(grp);
		gtk_clist_remove(GTK_CLIST(clist), row_number);
	}

	y=0;
	members = NULL;
	for (list = GTK_LIST(users)->selection; list; list=list->next) {
		gtk_label_get(GTK_LABEL(GTK_BIN(list->data)->child), 
			&row_text);
		members = g_slist_append(members,strdup(row_text));
	}
	members = g_slist_reverse(members);
	grp = create_group(gtk_entry_get_text(GTK_ENTRY(name)),
		gtk_entry_get_text(GTK_ENTRY(password)),
		atoi(gtk_entry_get_text(GTK_ENTRY(gid))),
		members);

	row = group_to_row(grp);
	gtk_clist_append (GTK_CLIST(clist), row);
	gtk_clist_set_row_data(GTK_CLIST(clist), GTK_CLIST(clist)->rows-1,
		grp);
	gtk_clist_sort(GTK_CLIST(clist));

	for (node = members; node; node = node->next)
		free(node->data);	
	g_slist_free(members);
	gtk_widget_destroy(dialog);
}

void save_groups_clicked (GtkWidget *clist) {

	gchar confirm_message[128];

	sprintf(confirm_message, "%s", 
"About to overwrite /etc/group. Are you sure? \
(Backup will be saved as /etc/group.gum");
	if (confirm_window("Confirm Save", confirm_message))
		save_groups(clist);
}

gchar *get_group_name (gint gid) {

	gint x;
	struct group *grp;

	for (x=0; x<GTK_CLIST(groups_clist)->rows; x++) {
		grp = gtk_clist_get_row_data(GTK_CLIST(groups_clist),x);
		if (grp->gr_gid == gid)
			return (grp->gr_name);
	}
	return (NULL);
}
