/*
    gUserMan- A GTK+ User manager
    Copyright (C) 1999 Scott Fritzinger

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "main.h"

extern gint     users_changed;
extern gint	groups_changed;
extern gint	debug_mode;

extern GtkWidget *users_clist;
extern GtkWidget *groups_clist;

extern gint	config_copy_skel;
extern gint	config_create_dir;
extern gint     config_min;
extern gint     config_max;
extern gint     config_gid;
extern gchar    config_dir[1024];
extern gchar    config_shell[1024];
extern gint     config_warn;
extern gint     config_inactive;
extern gint     config_expire;
extern gint	config_never;

extern gchar   *salt;
       gint	password_changed;

       gchar    users_sort_type = '1';

       GSList   *q_create_dir   = NULL;

GtkWidget *create_users_widget () {

	GtkWidget *mainbox, *hbox, *scrwin, *button,
		  *add, *edit, *remove, *template, *save, *quit;

	gint num_columns = 6;
	gint x;

	/* Create the main vbox that holds everything */
	mainbox = gtk_vbox_new(FALSE, 0);
	gtk_widget_show(mainbox); /* widget_realize gives a nasty core dump */
	gtk_widget_hide(mainbox); /* here for some reason. work around. */

	hbox = gtk_hbox_new(FALSE, 0);
	gtk_widget_show(hbox);
	gtk_box_pack_start(GTK_BOX(mainbox), hbox, FALSE, FALSE, 0);

	button = gtk_button_new_with_label("Login");
	gtk_widget_show(button);
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(user_sort_clicked), (gpointer)"0");
	gtk_widget_set_usize(button,60,20);
	gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 0);

	button = gtk_button_new_with_label("UID");
	gtk_widget_show(button);
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(user_sort_clicked), (gpointer)"1");
	gtk_widget_set_usize(button,30,20);
	gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 0);

	button = gtk_button_new_with_label("Group");
	gtk_widget_show(button);
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(user_sort_clicked), (gpointer)"2");
	gtk_widget_set_usize(button,55,20);
	gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 0);

	button = gtk_button_new_with_label("Name");
	gtk_widget_show(button);
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(user_sort_clicked), (gpointer)"3");
	gtk_widget_set_usize(button,135,20);
	gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 0);

	button = gtk_button_new_with_label("Home");
	gtk_widget_show(button);
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(user_sort_clicked), (gpointer)"4");
	gtk_widget_set_usize(button,130,20);
	gtk_box_pack_start(GTK_BOX(hbox), button, FALSE, FALSE, 0);

	button = gtk_button_new_with_label("Shell");
	gtk_widget_show(button);
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked",
		GTK_SIGNAL_FUNC(user_sort_clicked), (gpointer)"5");
	gtk_widget_set_usize(button,75,20);
	gtk_box_pack_start(GTK_BOX(hbox), button, TRUE, TRUE, 0);

	/* Create the clist to hold the passwd fields */
	users_clist = gtk_clist_new(num_columns);
	gtk_widget_show(users_clist);
	gtk_clist_set_shadow_type(GTK_CLIST(users_clist),GTK_SHADOW_NONE);
	gtk_clist_set_column_width(GTK_CLIST(users_clist), 0, 50);
	gtk_clist_set_column_width(GTK_CLIST(users_clist), 1, 25);
	gtk_clist_set_column_width(GTK_CLIST(users_clist), 2, 50);
	gtk_clist_set_column_width(GTK_CLIST(users_clist), 3, 125);
	gtk_clist_set_column_width(GTK_CLIST(users_clist), 4, 125);
	gtk_clist_set_column_width(GTK_CLIST(users_clist), 5, 75);

	gtk_clist_set_compare_func(GTK_CLIST(users_clist), 
		(GtkCListCompareFunc)compare_users_clist);

	for (x=0; x<num_columns; x++)
		gtk_clist_set_column_resizeable(
			GTK_CLIST(users_clist),x,FALSE);

	read_users(users_clist);

	gtk_clist_sort(GTK_CLIST(users_clist));

	gtk_signal_connect(GTK_OBJECT(users_clist), "select_row",
		GTK_SIGNAL_FUNC(user_clist_clicked), NULL);

	/* Create the scrolled window to hold the clist */
	scrwin = gtk_scrolled_window_new(NULL, NULL);
	gtk_widget_show(scrwin);
	gtk_widget_set_usize(scrwin, 520, 200);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrwin),
		GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
	gtk_scrolled_window_add_with_viewport(
		GTK_SCROLLED_WINDOW(scrwin),users_clist);
	gtk_box_pack_start_defaults(GTK_BOX(mainbox), scrwin);

	/* Create the horizontal box to hold the buttons */
	hbox = gtk_hbox_new(TRUE, 3);
	gtk_widget_show(hbox);
	gtk_box_pack_start(GTK_BOX(mainbox), hbox, FALSE, FALSE, 0);

	/* Create the add button */
	add = gtk_button_new_with_label("Add");
	gtk_widget_show(add);
	gtk_box_pack_start_defaults(GTK_BOX(hbox), add);
	gtk_signal_connect_object(GTK_OBJECT(add), "clicked",
		GTK_SIGNAL_FUNC(add_user_clicked), (gpointer)users_clist);

	/* Create the edit button */
	edit = gtk_button_new_with_label("Edit");
	gtk_widget_show(edit);
	gtk_box_pack_start_defaults(GTK_BOX(hbox), edit);
	gtk_signal_connect_object(GTK_OBJECT(edit), "clicked",
		GTK_SIGNAL_FUNC(edit_user_clicked), (gpointer)users_clist);

	/* Create the remove button */
	remove = gtk_button_new_with_label("Remove");
	gtk_widget_show(remove);
	gtk_box_pack_start_defaults(GTK_BOX(hbox), remove);
	gtk_signal_connect_object(GTK_OBJECT(remove), "clicked",
		GTK_SIGNAL_FUNC(remove_user_clicked), (gpointer)users_clist);

	/* Create the template button */
	template = gtk_button_new_with_label("Template...");
	gtk_widget_show(template);
	gtk_box_pack_start_defaults(GTK_BOX(hbox), template);
	gtk_signal_connect_object(GTK_OBJECT(template), "clicked",
		GTK_SIGNAL_FUNC(template_clicked), (gpointer)users_clist);

	/* Create the save button */
	save = gtk_button_new_with_label("Save Users");
	gtk_widget_show(save);
	gtk_box_pack_start_defaults(GTK_BOX(hbox), save);
	gtk_signal_connect_object(GTK_OBJECT(save), "clicked",
		GTK_SIGNAL_FUNC(save_users_clicked), (gpointer)users_clist);

	/* Create the quit button */
	quit = gtk_button_new_with_label("Quit");
	gtk_widget_show(quit);
	gtk_box_pack_start_defaults(GTK_BOX(hbox), quit);
	gtk_signal_connect_object(GTK_OBJECT(quit), "clicked",
		GTK_SIGNAL_FUNC(main_quit), NULL);

	/* Return the main vbox that has everything in it */
	return (mainbox);
}

gint compare_users_clist (GtkCList *clist, 
			  gpointer one, 
			  gpointer two) {

	struct User *user1 = ((GtkCListRow *)one)->data;
	struct User *user2 = ((GtkCListRow *)two)->data;

	switch (users_sort_type) {
		case '0':
			return(strcmp(user1->login, user2->login));
			break;
		case '2':
			return(strcmp(get_group_name(user1->gid),
				get_group_name(user2->gid)));
			break;
		case '3':
			return(strcmp(user1->name, user2->name));
			break;		
		case '4':
			return(strcmp(user1->dir, user2->dir));
			break;		
		case '5':
			return(strcmp(user1->shell, user2->shell));
			break;		
		default: 
			if (user1->uid < user2->uid)
				return (-1);
			if (user1->uid > user2->uid)
				return (1);
			return (0);
			break;
	}
	return(0);
}

void read_users (GtkWidget *clist) {

	FILE *pfile = NULL, *shfile = NULL;

	struct User *user;
	struct passwd *pwent, *pw; 
	struct spwd *spwent;

	gchar **row;
	
	GSList *temp=NULL;
	GSList *node;

	pfile = fopen(passwd_file, "r");
	while ((pwent = fgetpwent(pfile)) != NULL) {
		pw = copy_passwd(pwent);
		temp = g_slist_append(temp, copy_passwd(pwent));
	}
	fclose(pfile);

	shfile = fopen (shadow_file, "r");
	while ((spwent = fgetspent(shfile)) != NULL) {
		/* Find the user in the in the temp list */
		for (node = temp; node; node=node->next) {
			if (strcmp(spwent->sp_namp,
			  ((struct passwd*)node->data)->pw_name) == 0) {
				user = create_User(node->data, spwent);
				row = User_to_row(user);
				gtk_clist_append(GTK_CLIST(clist),
					row);
				gtk_clist_set_row_data(GTK_CLIST(clist),
					GTK_CLIST(clist)->rows-1,user);
			}
		}
	}
	fclose(shfile);

	/* Cleanup */
	for (node = temp; node; node=node->next)
		free_passwd(node->data);
	g_slist_free(temp);
}

void save_users (GtkWidget *clist) {

	FILE *pfile = NULL, *shfile = NULL;
	struct User   *user;
	struct passwd *pwent;
	struct spwd   *spwent;

	gint x, log_changed;

	gchar cp[256], oldsort;
	GString *str;	
	GSList *list;
	struct q_create_dir_entry *q;

	oldsort = users_sort_type;
	users_sort_type = '1';
	gtk_clist_sort(GTK_CLIST(users_clist));

	if (debug_mode)
		pfile = fopen ("passwd.debug", "w");
	   else
		pfile = fopen (passwd_file, "w");
	
	/* back up the current one */
	sprintf(cp, "cp %s %s.gum", passwd_file, passwd_file);
	system (cp);
	for (x=0; x<GTK_CLIST(clist)->rows; x++) {
		user = gtk_clist_get_row_data(GTK_CLIST(clist), x);
		pwent = create_passwd_from_User(user);
		putpwent(pwent, pfile);
		free_passwd(pwent);
	}
	fclose (pfile);

	if (debug_mode)
		shfile = fopen ("shadow.debug", "w");
	   else
		shfile = fopen (shadow_file, "w");

	/* back up the current one */
	sprintf(cp, "cp %s %s.gum", shadow_file, shadow_file);
	system (cp);
	for (x=0; x<GTK_CLIST(clist)->rows; x++) {
		user = gtk_clist_get_row_data(GTK_CLIST(clist), x);
		spwent = create_spwd_from_User(user);
		putspent(spwent, shfile);
		free_spwd(spwent);
	}
	fclose (shfile);

	str = g_string_new("-- Log of actions --\n");
	
	log_changed = 0;	
	for (list = q_create_dir; list; list = list->next) {
		q = (struct q_create_dir_entry *)list->data;
		if ((opendir(q->dir) == NULL) && (q->create)) {
			log_changed = 1;
			(void)mkdir(q->dir, 0700);
			g_string_sprintfa(str, "Created %s\n", q->dir);

			if (q->copy) {
				sprintf(cp, "cp -a /etc/skel/. %s",q->dir);
				system (cp);
				g_string_sprintfa(str, 
					"Copied files from /etc/skel to %s\n",
					q->dir);
			}

			sprintf(cp, "chown -R %s %s",q->login,q->dir);
			system (cp);
			g_string_sprintfa(str, 
				"Changed owner on %s to %s\n", 
				q->dir, q->login);

			sprintf(cp, "chgrp -R %i %s",q->gid,q->dir);
			system (cp);
			g_string_sprintfa(str,
				"Changed group ownership on %s to %i\n",
				q->dir, q->gid);

			sprintf(cp, "chmod -R 0700 %s", q->dir);
			system (cp);
			g_string_sprintfa(str,
				"Changed permissions on %s to 0700\n\n",
				q->dir);
		} else
			g_string_sprintfa(str,
				"Did NOT create %s", q->dir);
		free(q->dir);
		free(q->login);
		free(q);
	}
	if (log_changed)
		message_window_long("Log", str->str);
	g_string_free(str, TRUE);
	g_slist_free(q_create_dir);
	q_create_dir = NULL;
	users_changed = 0;

	users_sort_type = oldsort;
	gtk_clist_sort(GTK_CLIST(users_clist));

}

void user_sort_clicked (gchar *type) {

	users_sort_type = type[0];
	gtk_clist_sort(GTK_CLIST(users_clist));
}

gint user_clist_clicked (GtkWidget *clist, gint row, gint col, 
			GdkEvent *event) {

	if (event->type == GDK_2BUTTON_PRESS)
		edit_user_clicked(clist);
	return (FALSE);
}

void add_user_clicked (GtkWidget *clist) {
	edit_user_dialog(clist, TRUE);
}

void edit_user_clicked (GtkWidget *clist) {

	/* change to current selected row */
	edit_user_dialog(clist, FALSE);
}

void remove_user_clicked (GtkWidget *clist) {

	gint row_number;
	struct User *user;
	gchar mess[1024];

	if (!GTK_CLIST(clist)->selection) {
		message_window("Nothing Selected", 
		"Nothing is selected to be removed");
		return;
	}

	if (!confirm_window("Remove User", 
	"Are you sure you want to remove the user?"))
		return;

	row_number = GTK_CLIST(clist)->focus_row;
	user = gtk_clist_get_row_data(GTK_CLIST(clist), row_number);
	sprintf(mess,"Home directory (%s) was not removed", user->dir);
	free_User(user);
	gtk_clist_remove(GTK_CLIST(clist), row_number);

	users_changed = 1;
	message_window("Attention", mess);
}

void template_clicked (GtkWidget *clist) {

	GtkWidget *dialog, *table, *label, *vsep, *hbox, 
		  *min, *max, *gid, *dir, *create, *copy, *shell, 
		  *warn, *inact, *expire, *never,
		  *ok, *cancel;
	GtkObject   *adj;
	GtkTooltips *tooltip;
	GList 	    *list;

	struct group *grp;

	gchar num[32];
	gint x;

	dialog = gtk_dialog_new();
	gtk_widget_realize(dialog);
	gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_CENTER);
	gtk_window_set_title(GTK_WINDOW(dialog), "Edit User Template");
	gtk_container_set_border_width(GTK_CONTAINER(dialog), 5);

	table = gtk_table_new(12, 5, FALSE);
	gtk_widget_show(table);
	gtk_table_set_row_spacings(GTK_TABLE(table), 3);
	gtk_table_set_col_spacings(GTK_TABLE(table), 3);
	gtk_box_pack_start_defaults(GTK_BOX(GTK_DIALOG(dialog)->vbox),
		table);

	label = gtk_label_new("Group:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,0,1);

	label = gtk_label_new("Home Directory:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,1,2);

	label = gtk_label_new("Shell:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,3,4);

	label = gtk_label_new("Min days to change:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 3,4,0,1);

	label = gtk_label_new("Max days to change:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 3,4,1,2);

	label = gtk_label_new("Days for warning:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 3,4,2,3);

	label = gtk_label_new("Days before inactive:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 3,4,3,4);

	label = gtk_label_new("Months until account expires:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 3,4,4,5);

	vsep = gtk_vseparator_new();
	gtk_widget_show(vsep);
	gtk_table_attach_defaults(GTK_TABLE(table), vsep, 2,3,0,12);
	
        gid = gtk_combo_new();
        gtk_widget_show(gid);
        list = NULL;
        for (x=0; x<GTK_CLIST(groups_clist)->rows; x++) {
		grp = gtk_clist_get_row_data(GTK_CLIST(groups_clist),x);
                list = g_list_append(list, grp->gr_name);
	}
        gtk_combo_set_popdown_strings(GTK_COMBO(gid), list);
        gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(gid)->entry),FALSE);
        for (x=0; x<GTK_CLIST(groups_clist)->rows; x++) {
		grp = gtk_clist_get_row_data(GTK_CLIST(groups_clist),x);
		if (grp->gr_gid == config_gid)
			gtk_entry_set_text(
				GTK_ENTRY(GTK_COMBO(gid)->entry),
				grp->gr_name);
	}
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, gid, "Primary Group",NULL);	
	gtk_table_attach_defaults(GTK_TABLE(table), gid, 1,2,0,1);

	dir = gtk_entry_new();
	gtk_widget_show(dir);
	gtk_entry_set_text(GTK_ENTRY(dir), config_dir);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, dir, "Users' Base Home Directory",NULL);	
	gtk_table_attach_defaults(GTK_TABLE(table), dir, 1,2,1,2);

	create = gtk_check_button_new_with_label("Create home directories");
	gtk_widget_show(create);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(create),
		config_create_dir);
	gtk_table_attach_defaults(GTK_TABLE(table), create, 1,2,2,3);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, create, 
"Create new users' home directories automatically, setting permissions and ownership for the user", NULL);

	copy = gtk_check_button_new_with_label("Copy /etc/skel contents");
	gtk_widget_show(copy);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(copy),
		config_copy_skel);
	gtk_table_attach_defaults(GTK_TABLE(table), copy, 1,2,3,4);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, copy, 
"Copy contents of /etc/skel to a new user's home directory.", NULL);

	shell = gtk_entry_new();
	gtk_widget_show(shell);
	gtk_entry_set_text(GTK_ENTRY(shell), config_shell);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, shell, "User's Shell", NULL);
	gtk_table_attach_defaults(GTK_TABLE(table), shell, 1,2,4,5);

	min = gtk_entry_new();
	gtk_widget_show(min);
	sprintf(num, "%i", config_min);
	gtk_entry_set_text(GTK_ENTRY(min), num);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, min, 
"Minimum number of days users must wait to change their password after a previous change. \
(Set to '-1' if there is no minimum number of days)", NULL);	
	gtk_table_attach_defaults(GTK_TABLE(table), min, 4,5,0,1);

	max = gtk_entry_new();
	gtk_widget_show(max);
	sprintf(num, "%i", config_max);
	gtk_entry_set_text(GTK_ENTRY(max), num);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, max, 
"Maximum number of days users can keep a password before having to change it. \
(Set to '99999' if user doesn't ever have \
to change their password)", NULL);	
	gtk_table_attach_defaults(GTK_TABLE(table), max, 4,5,1,2);

	warn = gtk_entry_new();
	gtk_widget_show(warn);
	sprintf(num, "%i", config_warn);
	gtk_entry_set_text(GTK_ENTRY(warn), num);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, warn, 
"Number of days in advance to warn the users to change their password. \
(Set to '-1' for no warning)", NULL);	
	gtk_table_attach_defaults(GTK_TABLE(table), warn, 4,5,2,3);

	inact = gtk_entry_new();
	gtk_widget_show(inact);
	sprintf(num, "%i", config_inactive);
	gtk_entry_set_text(GTK_ENTRY(inact), num);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, inact, 
"Number of days after a required password change to deactivate the users' account.   \
(Set to '-1' to not deactivate the account)", NULL);	
	gtk_table_attach_defaults(GTK_TABLE(table), inact, 4,5,3,4);

	hbox = gtk_hbox_new(FALSE, 0);
	gtk_widget_show(hbox);
	gtk_table_attach_defaults(GTK_TABLE(table), hbox, 4,5,4,5);

	adj = gtk_adjustment_new(config_expire, 1, 9999, 1, 1, 0);
	expire = gtk_spin_button_new(GTK_ADJUSTMENT(adj), 0, 0);
	gtk_widget_show(expire);
	gtk_box_pack_start_defaults(GTK_BOX(hbox), expire);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, expire,
"Number of months after the creation of the account that it expires \
(If 'Never' is not selected)",NULL);

	never = gtk_check_button_new_with_label("Never");
	gtk_widget_show(never);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(never),
		config_never);
	gtk_box_pack_start_defaults(GTK_BOX(hbox), never);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, never, 
"Users' account never expires", NULL);

	ok = gtk_button_new_with_label("Save");
	gtk_widget_show(ok);
	gtk_box_pack_start_defaults(
		GTK_BOX(GTK_DIALOG(dialog)->action_area), ok);

	cancel = gtk_button_new_with_label("Cancel");
	gtk_widget_show(cancel);
	gtk_box_pack_start_defaults(
		GTK_BOX(GTK_DIALOG(dialog)->action_area), cancel);

	gtk_widget_show(dialog);

	if (wait_for_hide(dialog, ok, cancel) == 0) {
		if (GTK_IS_OBJECT(dialog))
			gtk_widget_destroy(dialog);
		return;
	}
	if (!GTK_IS_OBJECT(dialog))
		return;

	config_min = atoi(gtk_entry_get_text(GTK_ENTRY(min)));
	config_max = atoi(gtk_entry_get_text(GTK_ENTRY(max)));

	for(x=0; x<GTK_CLIST(groups_clist)->rows; x++) {
		grp = gtk_clist_get_row_data(GTK_CLIST(groups_clist),x);
		if (strcmp(grp->gr_name,
		   gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(gid)->entry)))
		   == 0)
			config_gid = grp->gr_gid;
	}

	sprintf(config_dir,"%s",strdup(gtk_entry_get_text(GTK_ENTRY(dir))));
	sprintf(config_shell,"%s",strdup(gtk_entry_get_text(GTK_ENTRY(shell))));
	config_warn = atoi(gtk_entry_get_text(GTK_ENTRY(warn)));
	config_inactive = atoi(gtk_entry_get_text(GTK_ENTRY(inact)));
	config_expire = gtk_spin_button_get_value_as_int(
		GTK_SPIN_BUTTON(expire));
	config_never = GTK_TOGGLE_BUTTON(never)->active;
	config_copy_skel = GTK_TOGGLE_BUTTON(copy)->active;
	config_create_dir = GTK_TOGGLE_BUTTON(create)->active;
	save_config();

	gtk_widget_destroy(dialog);
}

void save_users_clicked (GtkWidget *clist) {

	gchar confirm_message[128];

	sprintf(confirm_message, "%s", 
"About to overwrite /etc/passwd. Are you sure? \
(Backup will be saved as /etc/passwd.gum");
	if (confirm_window("Confirm Save", confirm_message)) {
		save_users(clist);
	}
}

void set_password_dialog (GtkWidget *entry) {

	GtkWidget *dialog, *label, *table, *first, *second,
		  *ok, *cancel;

	gchar *new1, *new2;

	dialog = gtk_dialog_new();
	gtk_widget_realize(dialog);
	gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_CENTER);
	gtk_window_set_title(GTK_WINDOW(dialog), "Set Password");
	gtk_container_set_border_width(GTK_CONTAINER(dialog), 5);

	table = gtk_table_new(2,2,FALSE);
	gtk_widget_show(table);
	gtk_box_pack_start_defaults(GTK_BOX(GTK_DIALOG(dialog)->vbox), table);

	label = gtk_label_new("New Password:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,0,1);

	label = gtk_label_new("Re-type New Password:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,1,2);

	first = gtk_entry_new();
	gtk_widget_show(first);
	gtk_entry_set_visibility(GTK_ENTRY(first), FALSE);
	gtk_table_attach_defaults(GTK_TABLE(table), first, 1,2,0,1);

	second = gtk_entry_new();
	gtk_widget_show(second);
	gtk_entry_set_visibility(GTK_ENTRY(second), FALSE);
	gtk_table_attach_defaults(GTK_TABLE(table), second, 1,2,1,2);

	ok = gtk_button_new_with_label("OK");
	gtk_widget_show(ok);
	gtk_box_pack_start_defaults(GTK_BOX(GTK_DIALOG(dialog)->action_area),
		ok);

	cancel = gtk_button_new_with_label("Cancel");
	gtk_widget_show(cancel);
	gtk_box_pack_start_defaults(GTK_BOX(GTK_DIALOG(dialog)->action_area),
		cancel);
	
	gtk_widget_show(dialog);

	if (wait_for_hide(dialog, ok, cancel) == 0) {
		if (GTK_IS_OBJECT(dialog))
			gtk_widget_destroy(dialog);
		return;
	}
	if (!GTK_IS_OBJECT(dialog))
		return;

	new1 = gtk_entry_get_text(GTK_ENTRY(first));
	new2 = gtk_entry_get_text(GTK_ENTRY(second));

	if (strcmp(new1, new2) != 0)
		message_window("Change Failed", "Passwords don't match.");
	   else {
		gtk_entry_set_text(GTK_ENTRY(entry), crypt(new1, salt));
		password_changed = 1;
	}

	gtk_widget_destroy(dialog);	
}

void edit_user_create_clicked (GtkWidget *toggle) {

	if (GTK_WIDGET_IS_SENSITIVE(toggle))
		gtk_widget_set_sensitive(toggle, FALSE);
	   else
		gtk_widget_set_sensitive(toggle, TRUE);
}

void edit_user_never_clicked (GtkWidget *toggle, GtkWidget *hbox) {

	GtkWidget *spinb;
	gboolean   value;
	GList     *child;

	if (GTK_TOGGLE_BUTTON(toggle)->active)
		value = FALSE;
	   else
		value = TRUE;

	child = gtk_container_children(GTK_CONTAINER(hbox));

	spinb = GTK_WIDGET(child->data);
	gtk_widget_set_sensitive(spinb, value);

	spinb = GTK_WIDGET(child->next->data);
	gtk_widget_set_sensitive(spinb, value);

	spinb = GTK_WIDGET(child->next->next->data);
	gtk_widget_set_sensitive(spinb, value);
}

void edit_user_dialog (GtkWidget *clist, gint new) {

	GtkWidget *dialog, *newdialog, *newtable,
		  *table, *hbox, *label, *vsep,
		  *newlogin, *newpassword, *newpassword2,
		  *login, *uid, *gid, *name, *dir, *create, *copy, *shell,
		  *password, *min, *max, *warn, *inact, 
		  *month, *day, *year, *never,
		  *change, *ok, *cancel;
	GtkTooltips *tooltip;
	GtkObject   *adj;
	GList 	    *list;

	gchar **row;
	gchar	*newloginname;
	gchar   num[32], str[1024];
	gint     row_number, x, y;

	struct passwd *pwent;
	struct spwd   *spwent;
	struct User   *user, *del;
	struct group  *grp;

	time_t t;
	struct tm *tm;

	long int day_changed, day_expires;
	unsigned long int flag;

	password_changed = 0;

	if ((!GTK_CLIST(clist)->selection) && (!new)) {
		message_window("Nothing Selected", 
		"Nothing is selected to be edited");
		return;
	}

	if (new) {
		newdialog = gtk_dialog_new();
		gtk_widget_realize(newdialog);
		gtk_window_set_title(GTK_WINDOW(newdialog), "New User");
		gtk_window_set_position (GTK_WINDOW (newdialog),
			GTK_WIN_POS_CENTER);
		gtk_container_set_border_width(GTK_CONTAINER(newdialog),
			5);

		newtable = gtk_table_new(3,2,FALSE);
		gtk_widget_show(newtable);
		gtk_box_pack_start_defaults(
			GTK_BOX(GTK_DIALOG(newdialog)->vbox),newtable);
	
		label = gtk_label_new("New user's login name: ");
		gtk_widget_show(label);
		gtk_misc_set_alignment(GTK_MISC(label), 0,0);
		gtk_table_attach_defaults(GTK_TABLE(newtable),
			label,0,1,0,1);
	
		newlogin = gtk_entry_new();
		gtk_widget_show(newlogin);
		gtk_table_attach_defaults(GTK_TABLE(newtable),
			newlogin,1,2,0,1);
		
		label = gtk_label_new("Password: ");
		gtk_widget_show(label);
		gtk_misc_set_alignment(GTK_MISC(label), 0,0);
		gtk_table_attach_defaults(GTK_TABLE(newtable),
			label,0,1,1,2);

		label = gtk_label_new("Retype Password: ");
		gtk_widget_show(label);
		gtk_misc_set_alignment(GTK_MISC(label), 0,0);
		gtk_table_attach_defaults(GTK_TABLE(newtable),
			label,0,1,2,3);
	
		newpassword = gtk_entry_new();
		gtk_widget_show(newpassword);
		gtk_entry_set_visibility(GTK_ENTRY(newpassword), FALSE);
		gtk_table_attach_defaults(GTK_TABLE(newtable),
			newpassword,1,2,1,2);

		newpassword2 = gtk_entry_new();
		gtk_widget_show(newpassword2);
		gtk_entry_set_visibility(GTK_ENTRY(newpassword2), FALSE);
		gtk_table_attach_defaults(GTK_TABLE(newtable),
			newpassword2,1,2,2,3);
	
		ok = gtk_button_new_with_label("OK");
		gtk_widget_show(ok);
		gtk_box_pack_start_defaults(
			GTK_BOX(GTK_DIALOG(newdialog)->action_area),
			ok);
	
		cancel = gtk_button_new_with_label("Cancel");
		gtk_widget_show(cancel);
		gtk_box_pack_start_defaults(
			GTK_BOX(GTK_DIALOG(newdialog)->action_area),
			cancel);

		gtk_widget_show(newdialog);

		if (wait_for_hide(newdialog, ok, cancel) == 0) {
			/* They clicked cancel... */
			if (GTK_IS_OBJECT(newdialog))
				gtk_widget_destroy(newdialog);
			return;
		}
		/* They clicked OK, but could have closed via the WM */
		if (!GTK_IS_OBJECT(newdialog))
			return;
		if (strcmp(gtk_entry_get_text(GTK_ENTRY(newpassword)),
		    gtk_entry_get_text(GTK_ENTRY(newpassword2))) != 0) {
			message_window("Error","New passwords don't match.");
			gtk_widget_destroy(newdialog);
			return;
		}
		newloginname = gtk_entry_get_text(GTK_ENTRY(newlogin));
		for (x=0;x<GTK_CLIST(clist)->rows; x++) {
			user = gtk_clist_get_row_data(GTK_CLIST(clist),x);
			if (strcmp(user->login, newloginname) == 0) {
				gtk_widget_destroy(newdialog);
				message_window("User exists",		 
"The login name you entered exists. \
Please choose another.");
				return;
			}
		}
	}	

	dialog = gtk_dialog_new();
	gtk_widget_realize(dialog);
	gtk_window_set_title(GTK_WINDOW(dialog), "Edit User");
	gtk_window_set_position (GTK_WINDOW (dialog), GTK_WIN_POS_CENTER);
	gtk_container_set_border_width(GTK_CONTAINER(dialog), 5);

	table = gtk_table_new(12, 5, FALSE);
	gtk_widget_show(table);
	gtk_table_set_row_spacings(GTK_TABLE(table), 3);
	gtk_table_set_col_spacings(GTK_TABLE(table), 3);
	gtk_box_pack_start_defaults(GTK_BOX(GTK_DIALOG(dialog)->vbox),
		table);

	label = gtk_label_new("Login:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,0,1);


	label = gtk_label_new("User ID:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,1,2);

	label = gtk_label_new("Group:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,2,3);

	label = gtk_label_new("Name:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,3,4);

	label = gtk_label_new("Home Directory:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,4,5);

	label = gtk_label_new("Shell:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	if (new)
		gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,7,8);
	   else
		gtk_table_attach_defaults(GTK_TABLE(table), label, 0,1,5,6);

	label = gtk_label_new("Password:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 3,4,0,1);

	label = gtk_label_new("Min days to change:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 3,4,2,3);

	label = gtk_label_new("Max days to change:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 3,4,3,4);

	label = gtk_label_new("Days for warning:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 3,4,4,5);

	label = gtk_label_new("Days before inactive:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 3,4,5,6);

	label = gtk_label_new("Date account expires:");
	gtk_widget_show(label);
	gtk_misc_set_alignment(GTK_MISC(label), 0,0);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 3,4,6,7);

	vsep = gtk_vseparator_new();
	gtk_widget_show(vsep);
	gtk_table_attach_defaults(GTK_TABLE(table), vsep, 2,3,0,12);
	
	login = gtk_entry_new();
	gtk_widget_show(login);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, login, "User's Login Name", NULL);	
	gtk_table_attach_defaults(GTK_TABLE(table), login, 1,2,0,1);

	uid = gtk_entry_new();
	gtk_widget_show(uid);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, uid, "User ID number", NULL);	
	gtk_table_attach_defaults(GTK_TABLE(table), uid, 1,2,1,2);

        gid = gtk_combo_new();
        gtk_widget_show(gid);
        list = NULL;
        for (x=0; x<GTK_CLIST(groups_clist)->rows; x++) {
		grp = gtk_clist_get_row_data(GTK_CLIST(groups_clist),x);
                list = g_list_append(list, grp->gr_name);
	}

        gtk_combo_set_popdown_strings(GTK_COMBO(gid), list);
        gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(gid)->entry),FALSE);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, gid, "Primary Group",NULL);	
	gtk_table_attach_defaults(GTK_TABLE(table), gid, 1,2,2,3);

	name = gtk_entry_new();
	gtk_widget_show(name);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, name, "User's Full Name", NULL);	
	gtk_table_attach_defaults(GTK_TABLE(table), name, 1,2,3,4);

	dir = gtk_entry_new();
	gtk_widget_show(dir);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, dir, "User's Home Directory", NULL);	
	gtk_table_attach_defaults(GTK_TABLE(table), dir, 1,2,4,5);

	if (new) {
		copy = gtk_check_button_new_with_label("Copy /etc/skel contents");
		gtk_widget_show(copy);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(copy),
			config_copy_skel);
		gtk_table_attach_defaults(GTK_TABLE(table), copy, 1,2,6,7);
		tooltip = gtk_tooltips_new();
		gtk_tooltips_set_tip(tooltip, copy, 
"Copy contents of /etc/skel to the new user's home directory.", NULL);

		create = gtk_check_button_new_with_label("Create home directory");
		gtk_widget_show(create);
		gtk_signal_connect_object(GTK_OBJECT(create), "clicked",
			GTK_SIGNAL_FUNC(edit_user_create_clicked),
			(gpointer)copy);
		gtk_widget_set_sensitive(copy, FALSE);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(create),
			config_create_dir);
		gtk_table_attach_defaults(GTK_TABLE(table), create, 1,2,5,6);
		tooltip = gtk_tooltips_new();
		gtk_tooltips_set_tip(tooltip, create, 
"Create new users' home directories automatically, setting permissions and ownership for the user", NULL);
	}

	shell = gtk_entry_new();
	gtk_widget_show(shell);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, shell, "User's Shell", NULL);
	if (new)
		gtk_table_attach_defaults(GTK_TABLE(table), shell, 1,2,7,8);
	   else
		gtk_table_attach_defaults(GTK_TABLE(table), shell, 1,2,5,6);

	password= gtk_entry_new();
	gtk_widget_show(password);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, password, 
"User's Encrypted Password. \
Do not edit unless you know what you're doing.  \
Click 'Change' to add/change the current password. \
Entering '*' here will not allow a user to log in.", NULL);
	gtk_table_attach_defaults(GTK_TABLE(table), password, 4,5,0,1);

	change = gtk_button_new_with_label("Set/Change Password");
	gtk_widget_show(change);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, change, 
		"Add/Change User's Password", NULL);	
	gtk_signal_connect_object(GTK_OBJECT(change), "clicked",
		GTK_SIGNAL_FUNC(set_password_dialog), GTK_OBJECT(password));
	gtk_table_attach_defaults(GTK_TABLE(table), change, 4,5,1,2);
	
	min = gtk_entry_new();
	gtk_widget_show(min);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, min, 
"Minimum number of days a user must wait to change their password after a previous change. \
(Set to '-1' if there is no minimum number of days)", NULL);	
	gtk_table_attach_defaults(GTK_TABLE(table), min, 4,5,2,3);

	max = gtk_entry_new();
	gtk_widget_show(max);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, max, 
"Maximum number of days a user can keep a password before having to change it. \
(Set to '99999' if user doesn't ever have \
to change their password)", NULL);	
	gtk_table_attach_defaults(GTK_TABLE(table), max, 4,5,3,4);

	warn = gtk_entry_new();
	gtk_widget_show(warn);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, warn, 
"Number of days in advance to warn the user to change their password. \
(Set to '-1' for no warning)", NULL);	
	gtk_table_attach_defaults(GTK_TABLE(table), warn, 4,5,4,5);

	inact = gtk_entry_new();
	gtk_widget_show(inact);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, inact, 
"Number of days after a required password change to deactivate the user's account. \
(Set to '-1' to not deactivate the account)", NULL);	
	gtk_table_attach_defaults(GTK_TABLE(table), inact, 4,5,5,6);

	hbox = gtk_hbox_new(FALSE, 0);
	gtk_widget_show(hbox);
	gtk_table_attach_defaults(GTK_TABLE(table), hbox, 4,5,6,7);

	t = time(&t);
	tm = gmtime(&t);

	adj = gtk_adjustment_new((float)tm->tm_mon+1, 1, 12, 1, 1, 0);
	month = gtk_spin_button_new(GTK_ADJUSTMENT(adj), 0, 0);
	gtk_widget_show(month);
	gtk_box_pack_start_defaults(GTK_BOX(hbox), month);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, month, 
"Last date the user can log in before the account expires", NULL);

	adj = gtk_adjustment_new((float)tm->tm_mday, 1, 31, 1, 1, 0);
	day = gtk_spin_button_new(GTK_ADJUSTMENT(adj), 0, 0);
	gtk_widget_show(day);
	gtk_box_pack_start_defaults(GTK_BOX(hbox), day);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, day,
"Last date the user can log in before the account expires", NULL);

	adj = gtk_adjustment_new((float)tm->tm_year+1900,1970,9999,1,1,0);
	/* Will they REALLY still be using gUserMan in the year 9999?
	   i don't THINK so. ;) */
	year = gtk_spin_button_new(GTK_ADJUSTMENT(adj), 0, 0);
	gtk_widget_show(year);
	gtk_box_pack_start_defaults(GTK_BOX(hbox), year);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, year, 
"Last date the user can log in before the account expires", NULL);

	never = gtk_check_button_new_with_label("Never");
	gtk_widget_show(never);
	gtk_signal_connect(GTK_OBJECT(never), "clicked",
		GTK_SIGNAL_FUNC(edit_user_never_clicked), hbox);
	gtk_box_pack_start_defaults(GTK_BOX(hbox), never);
	tooltip = gtk_tooltips_new();
	gtk_tooltips_set_tip(tooltip, never, 
"User's account never expires", NULL);

	if (!new) {
		/* If they selected something, and "new" wasn't clicked,
		   fill in the entries in the window with the proper
		   existing values. */
		row_number = GTK_CLIST(clist)->focus_row;
		user = gtk_clist_get_row_data(GTK_CLIST(clist),row_number);
		gtk_entry_set_text(GTK_ENTRY(login), user->login);
		sprintf(num, "%i", user->uid);
		gtk_entry_set_text(GTK_ENTRY(uid), num);
		gtk_entry_set_text(GTK_ENTRY(name), user->name);
		gtk_entry_set_text(GTK_ENTRY(dir), user->dir);
		gtk_entry_set_text(GTK_ENTRY(shell), user->shell);
		gtk_entry_set_text(GTK_ENTRY(password), user->password);
		sprintf(num, "%li", user->min_days_change);
		gtk_entry_set_text(GTK_ENTRY(min), num);
		sprintf(num, "%li", user->max_days_change);
		gtk_entry_set_text(GTK_ENTRY(max), num);
		sprintf(num, "%li", user->num_days_warning);
		gtk_entry_set_text(GTK_ENTRY(warn), num);
		sprintf(num, "%li", user->num_days_inactive);
		gtk_entry_set_text(GTK_ENTRY(inact), num);
		if (user->day_expires == -1)
			gtk_toggle_button_set_active(
				GTK_TOGGLE_BUTTON(never), TRUE);
		   else {
			day_expires = (user->day_expires) * 86400;
			tm = gmtime(&day_expires);
			gtk_spin_button_set_value(
				GTK_SPIN_BUTTON(month), tm->tm_mon+1);
			gtk_spin_button_set_value(
				GTK_SPIN_BUTTON(day), tm->tm_mday);
			gtk_spin_button_set_value(
				GTK_SPIN_BUTTON(year), tm->tm_year+1900);
		}
	}  else {
		row_number = GTK_CLIST(clist)->rows-1;
		user = gtk_clist_get_row_data(GTK_CLIST(clist),row_number);
		gtk_entry_set_text(GTK_ENTRY(login), 
			gtk_entry_get_text(GTK_ENTRY(newlogin)));
		sprintf(num, "%i", user->uid+1);
		gtk_entry_set_text(GTK_ENTRY(uid), num);
		sprintf(str, "%s/%s", config_dir, 
			gtk_entry_get_text(GTK_ENTRY(newlogin)));
		gtk_entry_set_text(GTK_ENTRY(dir), str);
		gtk_entry_set_text(GTK_ENTRY(shell), config_shell);
		sprintf(num, "%i", config_min);
		gtk_entry_set_text(GTK_ENTRY(password),
			crypt(gtk_entry_get_text(
			GTK_ENTRY(newpassword)),salt));
		gtk_entry_set_text(GTK_ENTRY(min), num);
		sprintf(num, "%i", config_max);
		gtk_entry_set_text(GTK_ENTRY(max), num);
		sprintf(num, "%i", config_warn);
		gtk_entry_set_text(GTK_ENTRY(warn), num);
		sprintf(num, "%i", config_inactive);
		gtk_entry_set_text(GTK_ENTRY(inact), num);
		if (config_never)
			gtk_toggle_button_set_active(
				GTK_TOGGLE_BUTTON(never), TRUE);
		x = tm->tm_mon + config_expire;
		y = tm->tm_year;
		if (x > 12) {
			x -= 12;
			y += 1;
		}
		gtk_spin_button_set_value(
			GTK_SPIN_BUTTON(month), x+1);
		gtk_spin_button_set_value(
			GTK_SPIN_BUTTON(day), tm->tm_mday);
		gtk_spin_button_set_value(
			GTK_SPIN_BUTTON(year), y+1900);
	}

	for (x=0; x<GTK_CLIST(groups_clist)->rows; x++) {
		grp = gtk_clist_get_row_data(
			GTK_CLIST(groups_clist),x);
		if (((new) && (grp->gr_gid == config_gid)) ||
		   ((!new) && (grp->gr_gid == user->gid))) {
			gtk_entry_set_text(
				GTK_ENTRY(GTK_COMBO(gid)->entry),
				grp->gr_name);
		}
	}

	ok = gtk_button_new_with_label("OK");
	gtk_widget_show(ok);
	gtk_box_pack_start_defaults(GTK_BOX(GTK_DIALOG(dialog)->action_area),
		ok);

	cancel = gtk_button_new_with_label("Cancel");
	gtk_widget_show(cancel);
	gtk_box_pack_start_defaults(GTK_BOX(GTK_DIALOG(dialog)->action_area),
		cancel);

	gtk_widget_show(dialog);

	if (wait_for_hide(dialog, ok, cancel) == 0) {
		/* They clicked cancel... */
		if (GTK_IS_OBJECT(dialog))
			gtk_widget_destroy(dialog);
		return;
	}
	/* They clicked OK, but could have closed via the WM */
	if (!GTK_IS_OBJECT(dialog))
		return;

	users_changed = 1; /* They changed something. */

	if ((password_changed) || (new)) {
		t = time(&t);
		day_changed = t / 86400;
		password_changed = 0;}
	   else {
		user = gtk_clist_get_row_data(GTK_CLIST(clist),row_number);
		day_changed = user->date_last_change;
	}

	if (new)
		flag = 0;
	   else {
		user = gtk_clist_get_row_data(GTK_CLIST(clist),row_number);
		flag = user->flag;
	}

	if (GTK_TOGGLE_BUTTON(never)->active)
		day_expires = -1;
	   else
		day_expires = date_to_time_t(
			atoi(gtk_entry_get_text(GTK_ENTRY(month)))-1,
			atoi(gtk_entry_get_text(GTK_ENTRY(day))),
			atoi(gtk_entry_get_text(GTK_ENTRY(year))))
			/ 86400 - 1;
/* Debug outs
	printf("expires: %li\n", day_expires);
	day_expires = day_expires * 86400;
	tm = gmtime(&day_expires);
	day_expires = day_expires / 86400;
	printf("   date: %i %i %i\n", tm->tm_mon, tm->tm_mday, tm->tm_year);
*/
	for (x=0; x<GTK_CLIST(groups_clist)->rows; x++) {
		grp = gtk_clist_get_row_data(GTK_CLIST(groups_clist),x);
		if (strcmp(grp->gr_name,
		    gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(gid)->entry)))
		    == 0)
			y =  grp->gr_gid;
	}

	pwent = create_passwd (
		gtk_entry_get_text(GTK_ENTRY(login)),
		"x",
		atoi(gtk_entry_get_text(GTK_ENTRY(uid))),	
		y,
		gtk_entry_get_text(GTK_ENTRY(name)),	
		gtk_entry_get_text(GTK_ENTRY(dir)),	
		gtk_entry_get_text(GTK_ENTRY(shell)));
	spwent = create_spwd (
		gtk_entry_get_text(GTK_ENTRY(login)),
		gtk_entry_get_text(GTK_ENTRY(password)),
		day_changed,
		atol(gtk_entry_get_text(GTK_ENTRY(min))),
		atol(gtk_entry_get_text(GTK_ENTRY(max))),
		atol(gtk_entry_get_text(GTK_ENTRY(warn))),
		atol(gtk_entry_get_text(GTK_ENTRY(inact))),
		day_expires,
		flag);
	user = create_User(pwent, spwent);
	if (!new) {
		del = gtk_clist_get_row_data(GTK_CLIST(clist),row_number);
		free_User (del);
		gtk_clist_remove(GTK_CLIST(users_clist), row_number);
	}
	row = User_to_row (user);
	gtk_clist_append(GTK_CLIST(clist), row);
	gtk_clist_set_row_data(GTK_CLIST(clist),GTK_CLIST(clist)->rows-1,
		user);

	gtk_clist_sort(GTK_CLIST(clist));

	if (new) {
		struct q_create_dir_entry *q;
		q = (struct q_create_dir_entry*)malloc(
			sizeof(struct q_create_dir_entry));
		if (GTK_TOGGLE_BUTTON(create)->active) {
			q->create = 1;
			if (GTK_TOGGLE_BUTTON(copy)->active)
				q->copy = 1;
			   else
				q->copy = 0;
			}
		   else
			q->create = 0;
		q->dir = strdup(gtk_entry_get_text(GTK_ENTRY(dir)));
		q->login = strdup(gtk_entry_get_text(GTK_ENTRY(login)));
		q->gid = y;
		q_create_dir = g_slist_append(q_create_dir, q);
		gtk_widget_destroy(newdialog);
	}

	gtk_widget_destroy(dialog);
}
